/*
 * Copyright (c) 2006-2011 Massachusetts General Hospital 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the i2b2 Software License v2.1 
 * which accompanies this distribution. 
 * 
 * Contributors:
 * 		Lori Phillips
 */

package edu.harvard.i2b2.eclipse.plugins.vista.table.views;

import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.params.HttpMethodParams;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

public class ImageViewer {

	
	  public void run(String location1, String location2, Shell parent) {
		    //Display display = new Display();
		    Shell shell = new Shell(parent);
		    shell.setSize(770,350);
		    shell.setText("i2b2 Vista image viewer"); //$NON-NLS-1$
		    createContents(shell, location1, location2);
		    shell.open();
		  }
	
	  /**
	   * Creates the main window's contents
	   * 
	   * @param shell the main window
	   * @param location the initial location
	   */
	  public void createContents(Shell shell, String location1, String location2) {
	   
	//	  System.out.println(location1 + " " + location2);
		  
		    // Create the composite to hold the buttons and text field
//		 Composite parent = new Composite(shell, SWT.NONE);  
		  
	    GridData gridData1 = new GridData(GridData.FILL_BOTH);
	//	gridData1.grabExcessVerticalSpace = true;
	//   gridData1.grabExcessHorizontalSpace = true;
	//	gridData1.heightHint = 200;
	//	gridData1.widthHint = 800;
		shell.setLayoutData(gridData1);
		GridLayout gridLayout = new GridLayout ();
		gridLayout.numColumns = 1;
		
		shell.setLayout(gridLayout);
		
		Label imageLabel1 = new Label(shell, SWT.NONE);
		Image image = getImage(location1);
		if(image != null)
			imageLabel1.setImage(image);
		
		/*		Composite legendComp = new Composite(shell, SWT.NONE);
		
		legendComp.setLayoutData(gridData1);
		GridLayout gridLayout2 = new GridLayout ();
		gridLayout2.numColumns = 1;
		gridLayout2.marginLeft = 110;
		gridLayout2.marginRight = 0;
		legendComp.setLayout(gridLayout2);
*/		
		Label imageLabel2 = new Label(shell, SWT.NONE);
		Image image2 = getImage(location2);
		if(image2 != null)
			imageLabel2.setImage(image2);
	  }
	  
	  
		private Image getImage(String url){

			Image image = null;

			HttpClient client = new HttpClient();
			GetMethod method = new GetMethod(url);

			// Provide custom retry handler is necessary
			method.getParams().setParameter(HttpMethodParams.RETRY_HANDLER, 
					new DefaultHttpMethodRetryHandler(3, false));
			

			method.getParams().setParameter(HttpMethodParams.SO_TIMEOUT, 
					new Integer(10000));

			try {
				// Execute the method.
				int statusCode = client.executeMethod(method);
				if (statusCode != HttpStatus.SC_OK) {
					System.err.println("Method failed: " + method.getStatusLine());
					method.releaseConnection();
					return image;
				}

				// Read the response body.
				
				InputStream in = method.getResponseBodyAsStream();
				image = new Image(Display.getCurrent(), in);
			

			} catch (HttpException e) {
				System.err.println("Fatal protocol violation: " + e.getMessage());
		//		e.printStackTrace();
			} catch (IOException e) {
				System.err.println("Fatal transport error: " + e.getMessage());
		//		e.printStackTrace();
			} finally {
				// Release the connection.
				method.releaseConnection();
			}  

			return image;
		}
}
