/*
* Copyright (c) 2006-2011 Massachusetts General Hospital 
 * All rights reserved. This program and the accompanying materials 
* are made available under the terms of the i2b2 Software License v2.1 
 * which accompanies this distribution. 
 * 
 * Contributors:
 *     Lori Phillips - initial API and implementation
 */
package edu.harvard.i2b2.eclipse.plugins.vista.table.views;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;

public class SnpLabelProvider  extends LabelProvider implements	ITableLabelProvider {
	
	public static final Class THIS_CLASS = SnpLabelProvider.class;	

	private static final Image CHECKED = ImageDescriptor.createFromFile(THIS_CLASS,
				"icons/checkBox_checked_Black.png").createImage();

	private static final Image UNCHECKED = ImageDescriptor.createFromFile(THIS_CLASS,
				"icons/checkBox_unchecked.png").createImage();
	
	private static final Image CONSERVATION = ImageDescriptor.createFromFile(THIS_CLASS,
	"icons/conservation.png").createImage();

	private TableViewer viewer;
	private Display display;
	
	public SnpLabelProvider(TableViewer viewer, Display display) {
		this.viewer = viewer;
		this.display = display;
	}
	
	
//	@Override
	public Image getColumnImage(Object element, int columnIndex) {
		// In case you don't like image just return null here
		if (columnIndex == 0) {
			if (((SnpModel) element).isShowPosition()) {
				return CHECKED;
			} else {
				return UNCHECKED;
			}
		}
		if (columnIndex == 4) {
	
			// return CONSERVATION;
			if(((SnpModel)element).isValid()){
				if(((SnpModel)element).getConservationImage() == null) {
					SnpConservationImageProvider.getInstance().getConservationImage((SnpModel)element, this.viewer, this.display).start();
				}
				//CONSERVATION;//SnpConservationImageProvider.getInstance().getConservationImage((SnpModel)element);
				return	((SnpModel)element).getConservationImage();
			}
				
			else
				return CONSERVATION;
		}	
		return null;
	}

//	@Override
	public String getColumnText(Object element, int columnIndex) {
		SnpModel snp = (SnpModel) element;
		switch (columnIndex) {
		case 1:
			return snp.getGenomicData().getSequenceVariant().getSystematicName();
		case 2:
			return snp.getGenomicData().getSequenceVariantLocation().getGeneName();
		case 3:
			return snp.getGenomicData().getChromosomeLocation().getChromosome();
		case 4:
			return "";
		case 5:
			return snp.getGenomicData().getSequenceVariantLocation().getFlankingSeq5();
			// WAS PolyPhen prediction
//			if(snp.getGenomicData().getSequenceVariant().getSystematicName().contains("c.215"))
//				return "Probably damaging";
//			else
//				return "";
		case 6:
			return snp.getGenomicData().getSequenceVariantLocation().getFlankingSeq3();
			
			//WAS Variant Type
//			if(snp.getGenomicData().getSequenceVariant().getSystematicName().contains("c.215"))
//				return "Non-synonymous coding";
//			if(snp.getGenomicData().getSequenceVariant().getSystematicName().contains("+"))
//				return "Non coding";
//			else
//				return "Synonymous coding";
//			return "";	
		case 0:
			return "";

		default:
			throw new RuntimeException("Should not happen");
		}

	}
}
