/*
* Copyright (c) 2006-2011 Massachusetts General Hospital 
 * All rights reserved. This program and the accompanying materials 
* are made available under the terms of the i2b2 Software License v2.1 
 * which accompanies this distribution. 
 * 
 * Contributors:
 *     Lori Phillips - initial API and implementation
 */
package edu.harvard.i2b2.eclipse.plugins.vista.table.views;

import org.eclipse.swt.graphics.Image;
import edu.harvard.i2b2.crcxmljaxb.datavo.vdo.GenomicMetadataType;

public class SnpModel {

	private boolean showPosition;
	private GenomicMetadataType genomicData;
	private Image	conservationImage;
	
	public GenomicMetadataType getGenomicData() {
		return genomicData;
	}
	public void setGenomicData(GenomicMetadataType genomicData) {
		this.genomicData = genomicData;
	}
	public Image getConservationImage(){
		return conservationImage;
	}
	public void setConservationImage(Image image){
		this.conservationImage = image;
	}
	public boolean isShowPosition() {
		return showPosition;
	}
	public void setShowPosition(boolean showPosition) {
		this.showPosition = showPosition;
	}
	
	
	// Checks to see if snp has gene name & flanking seq info...
	public boolean isValid() {
		if ((genomicData.getSequenceVariantLocation().getGeneName() != null) &&			
				(genomicData.getSequenceVariantLocation().getFlankingSeq3() != null)&&
				(genomicData.getSequenceVariantLocation().getFlankingSeq5() != null)) {
			
			if ((genomicData.getSequenceVariantLocation().getGeneName().length() != 0) &&			
				(genomicData.getSequenceVariantLocation().getFlankingSeq3().length() != 0)&&
				(genomicData.getSequenceVariantLocation().getFlankingSeq5().length() != 0))
				return true;
			else
				return false;
		}
		else
			return false;
	}
	
	
}
