/*
* Copyright (c) 2006-2011 Massachusetts General Hospital 
 * All rights reserved. This program and the accompanying materials 
* are made available under the terms of the i2b2 Software License v2.1 
 * which accompanies this distribution. 
 * 
 * Contributors:
 *     Lori Phillips - initial API and implementation
 */
package edu.harvard.i2b2.eclipse.plugins.vista.table.views;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class SnpModelProvider {
	private static SnpModelProvider content;
	private List<SnpModel> snps;
	private List<SnpModel> enabledSnps;
	
	private SnpModelProvider() {
		snps = new ArrayList<SnpModel>();
		enabledSnps = new ArrayList<SnpModel>();
	}
	public static synchronized SnpModelProvider getInstance() {
		if (content != null) {
			return content;
		}
		content = new SnpModelProvider();
		return content;
	}

	public List<SnpModel> getSnps() {
		return snps;
	}

	public List<SnpModel> getEnabledSnps() {
		enabledSnps.clear();
		Iterator<SnpModel> snpsIterator = snps.iterator();		
		while(snpsIterator.hasNext()){
			SnpModel snp = (SnpModel) snpsIterator.next();
			if(snp.isShowPosition())
				enabledSnps.add(snp);
		}
		return enabledSnps;
	}
}
