/*
 * Copyright (c) 2006-2011 Massachusetts General Hospital 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the i2b2 Software License v2.1 
 * which accompanies this distribution. 
 * 
 * Contributors:
 * 	     Lori Phillips
 */
package edu.harvard.i2b2.eclipse.plugins.vista.table.views;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;


/**
 *
 * @author  lcp5
 */
public class VistaDisplayOptionsDialog extends Dialog {
    
	private Button encRadio;
	private Button patRadio;
	
    /**
     * Creates new  TextDecryptorOptionsDialog
     */
    public VistaDisplayOptionsDialog(Shell parentShell) {
    	super(parentShell);
    	
    }
      	
    @Override
	protected Control createDialogArea(Composite parent){
    	Composite comp = (Composite)super.createDialogArea(parent);
    	comp.getShell().setText("Text Decryptor Options");
    	
        Group group = new Group(comp, SWT.NONE);
        group.setLayout(new GridLayout());
    	group.setText("Query by:");
    	
    	encRadio = new Button(group, SWT.RADIO);
    	encRadio.setSelection(Boolean.parseBoolean(
				System.getProperty("TextDecryptorQueryByEncounter")));
    	encRadio.setText("Encounter Number");
	
    	
    	patRadio = new Button(group, SWT.RADIO);
    	patRadio.setSelection(Boolean.parseBoolean(
				System.getProperty("TextDecryptorQueryByPatient")));
    	patRadio.setText("Patient Number");
    	
    	return parent;
    }  

    @Override
	protected void buttonPressed(int buttonId){	
    	// OK
    	if(buttonId == 0){
    		System.setProperty("TextDecryptorQueryByEncounter", String.valueOf(encRadio.getSelection()));
    		System.setProperty("TextDecryptorQueryByPatient", String.valueOf(patRadio.getSelection()));

        	close();
    	}
    	//Cancel
    	else if(buttonId ==1) {
    		close();
    	}
    }
    
 }
